package org.apache.ratis.proto.grpc;

import static org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.generateFullMethodName;
import static org.apache.ratis.thirdparty.io.grpc.stub.ClientCalls.asyncBidiStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ClientCalls.asyncClientStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ClientCalls.asyncServerStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ClientCalls.asyncUnaryCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ClientCalls.blockingServerStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ClientCalls.blockingUnaryCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ClientCalls.futureUnaryCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.asyncBidiStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.asyncClientStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.asyncServerStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.asyncUnaryCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.asyncUnimplementedStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall;

/**
 */
@javax.annotation.Generated(
    value = "by gRPC proto compiler (version 1.28.1)",
    comments = "Source: Grpc.proto")
public final class RaftClientProtocolServiceGrpc {

  private RaftClientProtocolServiceGrpc() {}

  public static final String SERVICE_NAME = "ratis.grpc.RaftClientProtocolService";

  // Static method descriptors that strictly reflect the proto.
  private static volatile org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto,
      org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> getSetConfigurationMethod;

  @org.apache.ratis.thirdparty.io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "setConfiguration",
      requestType = org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto.class,
      responseType = org.apache.ratis.proto.RaftProtos.RaftClientReplyProto.class,
      methodType = org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.MethodType.UNARY)
  public static org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto,
      org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> getSetConfigurationMethod() {
    org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto, org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> getSetConfigurationMethod;
    if ((getSetConfigurationMethod = RaftClientProtocolServiceGrpc.getSetConfigurationMethod) == null) {
      synchronized (RaftClientProtocolServiceGrpc.class) {
        if ((getSetConfigurationMethod = RaftClientProtocolServiceGrpc.getSetConfigurationMethod) == null) {
          RaftClientProtocolServiceGrpc.getSetConfigurationMethod = getSetConfigurationMethod =
              org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.<org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto, org.apache.ratis.proto.RaftProtos.RaftClientReplyProto>newBuilder()
              .setType(org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "setConfiguration"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoUtils.marshaller(
                  org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto.getDefaultInstance()))
              .setResponseMarshaller(org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoUtils.marshaller(
                  org.apache.ratis.proto.RaftProtos.RaftClientReplyProto.getDefaultInstance()))
              .setSchemaDescriptor(new RaftClientProtocolServiceMethodDescriptorSupplier("setConfiguration"))
              .build();
        }
      }
    }
    return getSetConfigurationMethod;
  }

  private static volatile org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.RaftClientRequestProto,
      org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> getOrderedMethod;

  @org.apache.ratis.thirdparty.io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "ordered",
      requestType = org.apache.ratis.proto.RaftProtos.RaftClientRequestProto.class,
      responseType = org.apache.ratis.proto.RaftProtos.RaftClientReplyProto.class,
      methodType = org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.MethodType.BIDI_STREAMING)
  public static org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.RaftClientRequestProto,
      org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> getOrderedMethod() {
    org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.RaftClientRequestProto, org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> getOrderedMethod;
    if ((getOrderedMethod = RaftClientProtocolServiceGrpc.getOrderedMethod) == null) {
      synchronized (RaftClientProtocolServiceGrpc.class) {
        if ((getOrderedMethod = RaftClientProtocolServiceGrpc.getOrderedMethod) == null) {
          RaftClientProtocolServiceGrpc.getOrderedMethod = getOrderedMethod =
              org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.<org.apache.ratis.proto.RaftProtos.RaftClientRequestProto, org.apache.ratis.proto.RaftProtos.RaftClientReplyProto>newBuilder()
              .setType(org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.MethodType.BIDI_STREAMING)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "ordered"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoUtils.marshaller(
                  org.apache.ratis.proto.RaftProtos.RaftClientRequestProto.getDefaultInstance()))
              .setResponseMarshaller(org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoUtils.marshaller(
                  org.apache.ratis.proto.RaftProtos.RaftClientReplyProto.getDefaultInstance()))
              .setSchemaDescriptor(new RaftClientProtocolServiceMethodDescriptorSupplier("ordered"))
              .build();
        }
      }
    }
    return getOrderedMethod;
  }

  private static volatile org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.RaftClientRequestProto,
      org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> getUnorderedMethod;

  @org.apache.ratis.thirdparty.io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "unordered",
      requestType = org.apache.ratis.proto.RaftProtos.RaftClientRequestProto.class,
      responseType = org.apache.ratis.proto.RaftProtos.RaftClientReplyProto.class,
      methodType = org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.MethodType.BIDI_STREAMING)
  public static org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.RaftClientRequestProto,
      org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> getUnorderedMethod() {
    org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.RaftClientRequestProto, org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> getUnorderedMethod;
    if ((getUnorderedMethod = RaftClientProtocolServiceGrpc.getUnorderedMethod) == null) {
      synchronized (RaftClientProtocolServiceGrpc.class) {
        if ((getUnorderedMethod = RaftClientProtocolServiceGrpc.getUnorderedMethod) == null) {
          RaftClientProtocolServiceGrpc.getUnorderedMethod = getUnorderedMethod =
              org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.<org.apache.ratis.proto.RaftProtos.RaftClientRequestProto, org.apache.ratis.proto.RaftProtos.RaftClientReplyProto>newBuilder()
              .setType(org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.MethodType.BIDI_STREAMING)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "unordered"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoUtils.marshaller(
                  org.apache.ratis.proto.RaftProtos.RaftClientRequestProto.getDefaultInstance()))
              .setResponseMarshaller(org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoUtils.marshaller(
                  org.apache.ratis.proto.RaftProtos.RaftClientReplyProto.getDefaultInstance()))
              .setSchemaDescriptor(new RaftClientProtocolServiceMethodDescriptorSupplier("unordered"))
              .build();
        }
      }
    }
    return getUnorderedMethod;
  }

  /**
   * Creates a new async stub that supports all call types for the service
   */
  public static RaftClientProtocolServiceStub newStub(org.apache.ratis.thirdparty.io.grpc.Channel channel) {
    org.apache.ratis.thirdparty.io.grpc.stub.AbstractStub.StubFactory<RaftClientProtocolServiceStub> factory =
      new org.apache.ratis.thirdparty.io.grpc.stub.AbstractStub.StubFactory<RaftClientProtocolServiceStub>() {
        @java.lang.Override
        public RaftClientProtocolServiceStub newStub(org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
          return new RaftClientProtocolServiceStub(channel, callOptions);
        }
      };
    return RaftClientProtocolServiceStub.newStub(factory, channel);
  }

  /**
   * Creates a new blocking-style stub that supports unary and streaming output calls on the service
   */
  public static RaftClientProtocolServiceBlockingStub newBlockingStub(
      org.apache.ratis.thirdparty.io.grpc.Channel channel) {
    org.apache.ratis.thirdparty.io.grpc.stub.AbstractStub.StubFactory<RaftClientProtocolServiceBlockingStub> factory =
      new org.apache.ratis.thirdparty.io.grpc.stub.AbstractStub.StubFactory<RaftClientProtocolServiceBlockingStub>() {
        @java.lang.Override
        public RaftClientProtocolServiceBlockingStub newStub(org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
          return new RaftClientProtocolServiceBlockingStub(channel, callOptions);
        }
      };
    return RaftClientProtocolServiceBlockingStub.newStub(factory, channel);
  }

  /**
   * Creates a new ListenableFuture-style stub that supports unary calls on the service
   */
  public static RaftClientProtocolServiceFutureStub newFutureStub(
      org.apache.ratis.thirdparty.io.grpc.Channel channel) {
    org.apache.ratis.thirdparty.io.grpc.stub.AbstractStub.StubFactory<RaftClientProtocolServiceFutureStub> factory =
      new org.apache.ratis.thirdparty.io.grpc.stub.AbstractStub.StubFactory<RaftClientProtocolServiceFutureStub>() {
        @java.lang.Override
        public RaftClientProtocolServiceFutureStub newStub(org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
          return new RaftClientProtocolServiceFutureStub(channel, callOptions);
        }
      };
    return RaftClientProtocolServiceFutureStub.newStub(factory, channel);
  }

  /**
   */
  public static abstract class RaftClientProtocolServiceImplBase implements org.apache.ratis.thirdparty.io.grpc.BindableService {

    /**
     * <pre>
     * A client-to-server RPC to set new raft configuration
     * </pre>
     */
    public void setConfiguration(org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto request,
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> responseObserver) {
      asyncUnimplementedUnaryCall(getSetConfigurationMethod(), responseObserver);
    }

    /**
     * <pre>
     * A client-to-server stream RPC to ordered async requests
     * </pre>
     */
    public org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RaftClientRequestProto> ordered(
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> responseObserver) {
      return asyncUnimplementedStreamingCall(getOrderedMethod(), responseObserver);
    }

    /**
     * <pre>
     * A client-to-server stream RPC for unordered async requests
     * </pre>
     */
    public org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RaftClientRequestProto> unordered(
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> responseObserver) {
      return asyncUnimplementedStreamingCall(getUnorderedMethod(), responseObserver);
    }

    @java.lang.Override public final org.apache.ratis.thirdparty.io.grpc.ServerServiceDefinition bindService() {
      return org.apache.ratis.thirdparty.io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
          .addMethod(
            getSetConfigurationMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto,
                org.apache.ratis.proto.RaftProtos.RaftClientReplyProto>(
                  this, METHODID_SET_CONFIGURATION)))
          .addMethod(
            getOrderedMethod(),
            asyncBidiStreamingCall(
              new MethodHandlers<
                org.apache.ratis.proto.RaftProtos.RaftClientRequestProto,
                org.apache.ratis.proto.RaftProtos.RaftClientReplyProto>(
                  this, METHODID_ORDERED)))
          .addMethod(
            getUnorderedMethod(),
            asyncBidiStreamingCall(
              new MethodHandlers<
                org.apache.ratis.proto.RaftProtos.RaftClientRequestProto,
                org.apache.ratis.proto.RaftProtos.RaftClientReplyProto>(
                  this, METHODID_UNORDERED)))
          .build();
    }
  }

  /**
   */
  public static final class RaftClientProtocolServiceStub extends org.apache.ratis.thirdparty.io.grpc.stub.AbstractAsyncStub<RaftClientProtocolServiceStub> {
    private RaftClientProtocolServiceStub(
        org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected RaftClientProtocolServiceStub build(
        org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
      return new RaftClientProtocolServiceStub(channel, callOptions);
    }

    /**
     * <pre>
     * A client-to-server RPC to set new raft configuration
     * </pre>
     */
    public void setConfiguration(org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto request,
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getSetConfigurationMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * A client-to-server stream RPC to ordered async requests
     * </pre>
     */
    public org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RaftClientRequestProto> ordered(
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> responseObserver) {
      return asyncBidiStreamingCall(
          getChannel().newCall(getOrderedMethod(), getCallOptions()), responseObserver);
    }

    /**
     * <pre>
     * A client-to-server stream RPC for unordered async requests
     * </pre>
     */
    public org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RaftClientRequestProto> unordered(
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> responseObserver) {
      return asyncBidiStreamingCall(
          getChannel().newCall(getUnorderedMethod(), getCallOptions()), responseObserver);
    }
  }

  /**
   */
  public static final class RaftClientProtocolServiceBlockingStub extends org.apache.ratis.thirdparty.io.grpc.stub.AbstractBlockingStub<RaftClientProtocolServiceBlockingStub> {
    private RaftClientProtocolServiceBlockingStub(
        org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected RaftClientProtocolServiceBlockingStub build(
        org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
      return new RaftClientProtocolServiceBlockingStub(channel, callOptions);
    }

    /**
     * <pre>
     * A client-to-server RPC to set new raft configuration
     * </pre>
     */
    public org.apache.ratis.proto.RaftProtos.RaftClientReplyProto setConfiguration(org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto request) {
      return blockingUnaryCall(
          getChannel(), getSetConfigurationMethod(), getCallOptions(), request);
    }
  }

  /**
   */
  public static final class RaftClientProtocolServiceFutureStub extends org.apache.ratis.thirdparty.io.grpc.stub.AbstractFutureStub<RaftClientProtocolServiceFutureStub> {
    private RaftClientProtocolServiceFutureStub(
        org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected RaftClientProtocolServiceFutureStub build(
        org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
      return new RaftClientProtocolServiceFutureStub(channel, callOptions);
    }

    /**
     * <pre>
     * A client-to-server RPC to set new raft configuration
     * </pre>
     */
    public org.apache.ratis.thirdparty.com.google.common.util.concurrent.ListenableFuture<org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> setConfiguration(
        org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto request) {
      return futureUnaryCall(
          getChannel().newCall(getSetConfigurationMethod(), getCallOptions()), request);
    }
  }

  private static final int METHODID_SET_CONFIGURATION = 0;
  private static final int METHODID_ORDERED = 1;
  private static final int METHODID_UNORDERED = 2;

  private static final class MethodHandlers<Req, Resp> implements
      org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
      org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
      org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
      org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {
    private final RaftClientProtocolServiceImplBase serviceImpl;
    private final int methodId;

    MethodHandlers(RaftClientProtocolServiceImplBase serviceImpl, int methodId) {
      this.serviceImpl = serviceImpl;
      this.methodId = methodId;
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public void invoke(Req request, org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_SET_CONFIGURATION:
          serviceImpl.setConfiguration((org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto) request,
              (org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RaftClientReplyProto>) responseObserver);
          break;
        default:
          throw new AssertionError();
      }
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<Req> invoke(
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_ORDERED:
          return (org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<Req>) serviceImpl.ordered(
              (org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RaftClientReplyProto>) responseObserver);
        case METHODID_UNORDERED:
          return (org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<Req>) serviceImpl.unordered(
              (org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RaftClientReplyProto>) responseObserver);
        default:
          throw new AssertionError();
      }
    }
  }

  private static abstract class RaftClientProtocolServiceBaseDescriptorSupplier
      implements org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoFileDescriptorSupplier, org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoServiceDescriptorSupplier {
    RaftClientProtocolServiceBaseDescriptorSupplier() {}

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FileDescriptor getFileDescriptor() {
      return org.apache.ratis.proto.grpc.GrpcProtos.getDescriptor();
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.ServiceDescriptor getServiceDescriptor() {
      return getFileDescriptor().findServiceByName("RaftClientProtocolService");
    }
  }

  private static final class RaftClientProtocolServiceFileDescriptorSupplier
      extends RaftClientProtocolServiceBaseDescriptorSupplier {
    RaftClientProtocolServiceFileDescriptorSupplier() {}
  }

  private static final class RaftClientProtocolServiceMethodDescriptorSupplier
      extends RaftClientProtocolServiceBaseDescriptorSupplier
      implements org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoMethodDescriptorSupplier {
    private final String methodName;

    RaftClientProtocolServiceMethodDescriptorSupplier(String methodName) {
      this.methodName = methodName;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.MethodDescriptor getMethodDescriptor() {
      return getServiceDescriptor().findMethodByName(methodName);
    }
  }

  private static volatile org.apache.ratis.thirdparty.io.grpc.ServiceDescriptor serviceDescriptor;

  public static org.apache.ratis.thirdparty.io.grpc.ServiceDescriptor getServiceDescriptor() {
    org.apache.ratis.thirdparty.io.grpc.ServiceDescriptor result = serviceDescriptor;
    if (result == null) {
      synchronized (RaftClientProtocolServiceGrpc.class) {
        result = serviceDescriptor;
        if (result == null) {
          serviceDescriptor = result = org.apache.ratis.thirdparty.io.grpc.ServiceDescriptor.newBuilder(SERVICE_NAME)
              .setSchemaDescriptor(new RaftClientProtocolServiceFileDescriptorSupplier())
              .addMethod(getSetConfigurationMethod())
              .addMethod(getOrderedMethod())
              .addMethod(getUnorderedMethod())
              .build();
        }
      }
    }
    return result;
  }
}
