package org.apache.ratis.proto.hadoop;

import static org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.generateFullMethodName;
import static org.apache.ratis.thirdparty.io.grpc.stub.ClientCalls.asyncBidiStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ClientCalls.asyncClientStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ClientCalls.asyncServerStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ClientCalls.asyncUnaryCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ClientCalls.blockingServerStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ClientCalls.blockingUnaryCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ClientCalls.futureUnaryCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.asyncBidiStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.asyncClientStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.asyncServerStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.asyncUnaryCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.asyncUnimplementedStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall;

/**
 */
@javax.annotation.Generated(
    value = "by gRPC proto compiler (version 1.28.1)",
    comments = "Source: Hadoop.proto")
public final class CombinedClientProtocolServiceGrpc {

  private CombinedClientProtocolServiceGrpc() {}

  public static final String SERVICE_NAME = "ratis.hadoop.CombinedClientProtocolService";

  // Static method descriptors that strictly reflect the proto.
  private static volatile org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.RaftClientRequestProto,
      org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> getSubmitClientRequestMethod;

  @org.apache.ratis.thirdparty.io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "submitClientRequest",
      requestType = org.apache.ratis.proto.RaftProtos.RaftClientRequestProto.class,
      responseType = org.apache.ratis.proto.RaftProtos.RaftClientReplyProto.class,
      methodType = org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.MethodType.UNARY)
  public static org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.RaftClientRequestProto,
      org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> getSubmitClientRequestMethod() {
    org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.RaftClientRequestProto, org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> getSubmitClientRequestMethod;
    if ((getSubmitClientRequestMethod = CombinedClientProtocolServiceGrpc.getSubmitClientRequestMethod) == null) {
      synchronized (CombinedClientProtocolServiceGrpc.class) {
        if ((getSubmitClientRequestMethod = CombinedClientProtocolServiceGrpc.getSubmitClientRequestMethod) == null) {
          CombinedClientProtocolServiceGrpc.getSubmitClientRequestMethod = getSubmitClientRequestMethod =
              org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.<org.apache.ratis.proto.RaftProtos.RaftClientRequestProto, org.apache.ratis.proto.RaftProtos.RaftClientReplyProto>newBuilder()
              .setType(org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "submitClientRequest"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoUtils.marshaller(
                  org.apache.ratis.proto.RaftProtos.RaftClientRequestProto.getDefaultInstance()))
              .setResponseMarshaller(org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoUtils.marshaller(
                  org.apache.ratis.proto.RaftProtos.RaftClientReplyProto.getDefaultInstance()))
              .setSchemaDescriptor(new CombinedClientProtocolServiceMethodDescriptorSupplier("submitClientRequest"))
              .build();
        }
      }
    }
    return getSubmitClientRequestMethod;
  }

  private static volatile org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto,
      org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> getSetConfigurationMethod;

  @org.apache.ratis.thirdparty.io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "setConfiguration",
      requestType = org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto.class,
      responseType = org.apache.ratis.proto.RaftProtos.RaftClientReplyProto.class,
      methodType = org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.MethodType.UNARY)
  public static org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto,
      org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> getSetConfigurationMethod() {
    org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto, org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> getSetConfigurationMethod;
    if ((getSetConfigurationMethod = CombinedClientProtocolServiceGrpc.getSetConfigurationMethod) == null) {
      synchronized (CombinedClientProtocolServiceGrpc.class) {
        if ((getSetConfigurationMethod = CombinedClientProtocolServiceGrpc.getSetConfigurationMethod) == null) {
          CombinedClientProtocolServiceGrpc.getSetConfigurationMethod = getSetConfigurationMethod =
              org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.<org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto, org.apache.ratis.proto.RaftProtos.RaftClientReplyProto>newBuilder()
              .setType(org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "setConfiguration"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoUtils.marshaller(
                  org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto.getDefaultInstance()))
              .setResponseMarshaller(org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoUtils.marshaller(
                  org.apache.ratis.proto.RaftProtos.RaftClientReplyProto.getDefaultInstance()))
              .setSchemaDescriptor(new CombinedClientProtocolServiceMethodDescriptorSupplier("setConfiguration"))
              .build();
        }
      }
    }
    return getSetConfigurationMethod;
  }

  private static volatile org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.GroupManagementRequestProto,
      org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> getGroupManagementMethod;

  @org.apache.ratis.thirdparty.io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "groupManagement",
      requestType = org.apache.ratis.proto.RaftProtos.GroupManagementRequestProto.class,
      responseType = org.apache.ratis.proto.RaftProtos.RaftClientReplyProto.class,
      methodType = org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.MethodType.UNARY)
  public static org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.GroupManagementRequestProto,
      org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> getGroupManagementMethod() {
    org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.GroupManagementRequestProto, org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> getGroupManagementMethod;
    if ((getGroupManagementMethod = CombinedClientProtocolServiceGrpc.getGroupManagementMethod) == null) {
      synchronized (CombinedClientProtocolServiceGrpc.class) {
        if ((getGroupManagementMethod = CombinedClientProtocolServiceGrpc.getGroupManagementMethod) == null) {
          CombinedClientProtocolServiceGrpc.getGroupManagementMethod = getGroupManagementMethod =
              org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.<org.apache.ratis.proto.RaftProtos.GroupManagementRequestProto, org.apache.ratis.proto.RaftProtos.RaftClientReplyProto>newBuilder()
              .setType(org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "groupManagement"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoUtils.marshaller(
                  org.apache.ratis.proto.RaftProtos.GroupManagementRequestProto.getDefaultInstance()))
              .setResponseMarshaller(org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoUtils.marshaller(
                  org.apache.ratis.proto.RaftProtos.RaftClientReplyProto.getDefaultInstance()))
              .setSchemaDescriptor(new CombinedClientProtocolServiceMethodDescriptorSupplier("groupManagement"))
              .build();
        }
      }
    }
    return getGroupManagementMethod;
  }

  private static volatile org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.GroupListRequestProto,
      org.apache.ratis.proto.RaftProtos.GroupListReplyProto> getGroupListMethod;

  @org.apache.ratis.thirdparty.io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "groupList",
      requestType = org.apache.ratis.proto.RaftProtos.GroupListRequestProto.class,
      responseType = org.apache.ratis.proto.RaftProtos.GroupListReplyProto.class,
      methodType = org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.MethodType.UNARY)
  public static org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.GroupListRequestProto,
      org.apache.ratis.proto.RaftProtos.GroupListReplyProto> getGroupListMethod() {
    org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.GroupListRequestProto, org.apache.ratis.proto.RaftProtos.GroupListReplyProto> getGroupListMethod;
    if ((getGroupListMethod = CombinedClientProtocolServiceGrpc.getGroupListMethod) == null) {
      synchronized (CombinedClientProtocolServiceGrpc.class) {
        if ((getGroupListMethod = CombinedClientProtocolServiceGrpc.getGroupListMethod) == null) {
          CombinedClientProtocolServiceGrpc.getGroupListMethod = getGroupListMethod =
              org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.<org.apache.ratis.proto.RaftProtos.GroupListRequestProto, org.apache.ratis.proto.RaftProtos.GroupListReplyProto>newBuilder()
              .setType(org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "groupList"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoUtils.marshaller(
                  org.apache.ratis.proto.RaftProtos.GroupListRequestProto.getDefaultInstance()))
              .setResponseMarshaller(org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoUtils.marshaller(
                  org.apache.ratis.proto.RaftProtos.GroupListReplyProto.getDefaultInstance()))
              .setSchemaDescriptor(new CombinedClientProtocolServiceMethodDescriptorSupplier("groupList"))
              .build();
        }
      }
    }
    return getGroupListMethod;
  }

  private static volatile org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.GroupInfoRequestProto,
      org.apache.ratis.proto.RaftProtos.GroupInfoReplyProto> getGroupInfoMethod;

  @org.apache.ratis.thirdparty.io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "groupInfo",
      requestType = org.apache.ratis.proto.RaftProtos.GroupInfoRequestProto.class,
      responseType = org.apache.ratis.proto.RaftProtos.GroupInfoReplyProto.class,
      methodType = org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.MethodType.UNARY)
  public static org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.GroupInfoRequestProto,
      org.apache.ratis.proto.RaftProtos.GroupInfoReplyProto> getGroupInfoMethod() {
    org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.GroupInfoRequestProto, org.apache.ratis.proto.RaftProtos.GroupInfoReplyProto> getGroupInfoMethod;
    if ((getGroupInfoMethod = CombinedClientProtocolServiceGrpc.getGroupInfoMethod) == null) {
      synchronized (CombinedClientProtocolServiceGrpc.class) {
        if ((getGroupInfoMethod = CombinedClientProtocolServiceGrpc.getGroupInfoMethod) == null) {
          CombinedClientProtocolServiceGrpc.getGroupInfoMethod = getGroupInfoMethod =
              org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.<org.apache.ratis.proto.RaftProtos.GroupInfoRequestProto, org.apache.ratis.proto.RaftProtos.GroupInfoReplyProto>newBuilder()
              .setType(org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "groupInfo"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoUtils.marshaller(
                  org.apache.ratis.proto.RaftProtos.GroupInfoRequestProto.getDefaultInstance()))
              .setResponseMarshaller(org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoUtils.marshaller(
                  org.apache.ratis.proto.RaftProtos.GroupInfoReplyProto.getDefaultInstance()))
              .setSchemaDescriptor(new CombinedClientProtocolServiceMethodDescriptorSupplier("groupInfo"))
              .build();
        }
      }
    }
    return getGroupInfoMethod;
  }

  /**
   * Creates a new async stub that supports all call types for the service
   */
  public static CombinedClientProtocolServiceStub newStub(org.apache.ratis.thirdparty.io.grpc.Channel channel) {
    org.apache.ratis.thirdparty.io.grpc.stub.AbstractStub.StubFactory<CombinedClientProtocolServiceStub> factory =
      new org.apache.ratis.thirdparty.io.grpc.stub.AbstractStub.StubFactory<CombinedClientProtocolServiceStub>() {
        @java.lang.Override
        public CombinedClientProtocolServiceStub newStub(org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
          return new CombinedClientProtocolServiceStub(channel, callOptions);
        }
      };
    return CombinedClientProtocolServiceStub.newStub(factory, channel);
  }

  /**
   * Creates a new blocking-style stub that supports unary and streaming output calls on the service
   */
  public static CombinedClientProtocolServiceBlockingStub newBlockingStub(
      org.apache.ratis.thirdparty.io.grpc.Channel channel) {
    org.apache.ratis.thirdparty.io.grpc.stub.AbstractStub.StubFactory<CombinedClientProtocolServiceBlockingStub> factory =
      new org.apache.ratis.thirdparty.io.grpc.stub.AbstractStub.StubFactory<CombinedClientProtocolServiceBlockingStub>() {
        @java.lang.Override
        public CombinedClientProtocolServiceBlockingStub newStub(org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
          return new CombinedClientProtocolServiceBlockingStub(channel, callOptions);
        }
      };
    return CombinedClientProtocolServiceBlockingStub.newStub(factory, channel);
  }

  /**
   * Creates a new ListenableFuture-style stub that supports unary calls on the service
   */
  public static CombinedClientProtocolServiceFutureStub newFutureStub(
      org.apache.ratis.thirdparty.io.grpc.Channel channel) {
    org.apache.ratis.thirdparty.io.grpc.stub.AbstractStub.StubFactory<CombinedClientProtocolServiceFutureStub> factory =
      new org.apache.ratis.thirdparty.io.grpc.stub.AbstractStub.StubFactory<CombinedClientProtocolServiceFutureStub>() {
        @java.lang.Override
        public CombinedClientProtocolServiceFutureStub newStub(org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
          return new CombinedClientProtocolServiceFutureStub(channel, callOptions);
        }
      };
    return CombinedClientProtocolServiceFutureStub.newStub(factory, channel);
  }

  /**
   */
  public static abstract class CombinedClientProtocolServiceImplBase implements org.apache.ratis.thirdparty.io.grpc.BindableService {

    /**
     */
    public void submitClientRequest(org.apache.ratis.proto.RaftProtos.RaftClientRequestProto request,
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> responseObserver) {
      asyncUnimplementedUnaryCall(getSubmitClientRequestMethod(), responseObserver);
    }

    /**
     */
    public void setConfiguration(org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto request,
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> responseObserver) {
      asyncUnimplementedUnaryCall(getSetConfigurationMethod(), responseObserver);
    }

    /**
     */
    public void groupManagement(org.apache.ratis.proto.RaftProtos.GroupManagementRequestProto request,
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> responseObserver) {
      asyncUnimplementedUnaryCall(getGroupManagementMethod(), responseObserver);
    }

    /**
     */
    public void groupList(org.apache.ratis.proto.RaftProtos.GroupListRequestProto request,
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.GroupListReplyProto> responseObserver) {
      asyncUnimplementedUnaryCall(getGroupListMethod(), responseObserver);
    }

    /**
     */
    public void groupInfo(org.apache.ratis.proto.RaftProtos.GroupInfoRequestProto request,
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.GroupInfoReplyProto> responseObserver) {
      asyncUnimplementedUnaryCall(getGroupInfoMethod(), responseObserver);
    }

    @java.lang.Override public final org.apache.ratis.thirdparty.io.grpc.ServerServiceDefinition bindService() {
      return org.apache.ratis.thirdparty.io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
          .addMethod(
            getSubmitClientRequestMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                org.apache.ratis.proto.RaftProtos.RaftClientRequestProto,
                org.apache.ratis.proto.RaftProtos.RaftClientReplyProto>(
                  this, METHODID_SUBMIT_CLIENT_REQUEST)))
          .addMethod(
            getSetConfigurationMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto,
                org.apache.ratis.proto.RaftProtos.RaftClientReplyProto>(
                  this, METHODID_SET_CONFIGURATION)))
          .addMethod(
            getGroupManagementMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                org.apache.ratis.proto.RaftProtos.GroupManagementRequestProto,
                org.apache.ratis.proto.RaftProtos.RaftClientReplyProto>(
                  this, METHODID_GROUP_MANAGEMENT)))
          .addMethod(
            getGroupListMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                org.apache.ratis.proto.RaftProtos.GroupListRequestProto,
                org.apache.ratis.proto.RaftProtos.GroupListReplyProto>(
                  this, METHODID_GROUP_LIST)))
          .addMethod(
            getGroupInfoMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                org.apache.ratis.proto.RaftProtos.GroupInfoRequestProto,
                org.apache.ratis.proto.RaftProtos.GroupInfoReplyProto>(
                  this, METHODID_GROUP_INFO)))
          .build();
    }
  }

  /**
   */
  public static final class CombinedClientProtocolServiceStub extends org.apache.ratis.thirdparty.io.grpc.stub.AbstractAsyncStub<CombinedClientProtocolServiceStub> {
    private CombinedClientProtocolServiceStub(
        org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected CombinedClientProtocolServiceStub build(
        org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
      return new CombinedClientProtocolServiceStub(channel, callOptions);
    }

    /**
     */
    public void submitClientRequest(org.apache.ratis.proto.RaftProtos.RaftClientRequestProto request,
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getSubmitClientRequestMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void setConfiguration(org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto request,
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getSetConfigurationMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void groupManagement(org.apache.ratis.proto.RaftProtos.GroupManagementRequestProto request,
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGroupManagementMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void groupList(org.apache.ratis.proto.RaftProtos.GroupListRequestProto request,
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.GroupListReplyProto> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGroupListMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void groupInfo(org.apache.ratis.proto.RaftProtos.GroupInfoRequestProto request,
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.GroupInfoReplyProto> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGroupInfoMethod(), getCallOptions()), request, responseObserver);
    }
  }

  /**
   */
  public static final class CombinedClientProtocolServiceBlockingStub extends org.apache.ratis.thirdparty.io.grpc.stub.AbstractBlockingStub<CombinedClientProtocolServiceBlockingStub> {
    private CombinedClientProtocolServiceBlockingStub(
        org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected CombinedClientProtocolServiceBlockingStub build(
        org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
      return new CombinedClientProtocolServiceBlockingStub(channel, callOptions);
    }

    /**
     */
    public org.apache.ratis.proto.RaftProtos.RaftClientReplyProto submitClientRequest(org.apache.ratis.proto.RaftProtos.RaftClientRequestProto request) {
      return blockingUnaryCall(
          getChannel(), getSubmitClientRequestMethod(), getCallOptions(), request);
    }

    /**
     */
    public org.apache.ratis.proto.RaftProtos.RaftClientReplyProto setConfiguration(org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto request) {
      return blockingUnaryCall(
          getChannel(), getSetConfigurationMethod(), getCallOptions(), request);
    }

    /**
     */
    public org.apache.ratis.proto.RaftProtos.RaftClientReplyProto groupManagement(org.apache.ratis.proto.RaftProtos.GroupManagementRequestProto request) {
      return blockingUnaryCall(
          getChannel(), getGroupManagementMethod(), getCallOptions(), request);
    }

    /**
     */
    public org.apache.ratis.proto.RaftProtos.GroupListReplyProto groupList(org.apache.ratis.proto.RaftProtos.GroupListRequestProto request) {
      return blockingUnaryCall(
          getChannel(), getGroupListMethod(), getCallOptions(), request);
    }

    /**
     */
    public org.apache.ratis.proto.RaftProtos.GroupInfoReplyProto groupInfo(org.apache.ratis.proto.RaftProtos.GroupInfoRequestProto request) {
      return blockingUnaryCall(
          getChannel(), getGroupInfoMethod(), getCallOptions(), request);
    }
  }

  /**
   */
  public static final class CombinedClientProtocolServiceFutureStub extends org.apache.ratis.thirdparty.io.grpc.stub.AbstractFutureStub<CombinedClientProtocolServiceFutureStub> {
    private CombinedClientProtocolServiceFutureStub(
        org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected CombinedClientProtocolServiceFutureStub build(
        org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
      return new CombinedClientProtocolServiceFutureStub(channel, callOptions);
    }

    /**
     */
    public org.apache.ratis.thirdparty.com.google.common.util.concurrent.ListenableFuture<org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> submitClientRequest(
        org.apache.ratis.proto.RaftProtos.RaftClientRequestProto request) {
      return futureUnaryCall(
          getChannel().newCall(getSubmitClientRequestMethod(), getCallOptions()), request);
    }

    /**
     */
    public org.apache.ratis.thirdparty.com.google.common.util.concurrent.ListenableFuture<org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> setConfiguration(
        org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto request) {
      return futureUnaryCall(
          getChannel().newCall(getSetConfigurationMethod(), getCallOptions()), request);
    }

    /**
     */
    public org.apache.ratis.thirdparty.com.google.common.util.concurrent.ListenableFuture<org.apache.ratis.proto.RaftProtos.RaftClientReplyProto> groupManagement(
        org.apache.ratis.proto.RaftProtos.GroupManagementRequestProto request) {
      return futureUnaryCall(
          getChannel().newCall(getGroupManagementMethod(), getCallOptions()), request);
    }

    /**
     */
    public org.apache.ratis.thirdparty.com.google.common.util.concurrent.ListenableFuture<org.apache.ratis.proto.RaftProtos.GroupListReplyProto> groupList(
        org.apache.ratis.proto.RaftProtos.GroupListRequestProto request) {
      return futureUnaryCall(
          getChannel().newCall(getGroupListMethod(), getCallOptions()), request);
    }

    /**
     */
    public org.apache.ratis.thirdparty.com.google.common.util.concurrent.ListenableFuture<org.apache.ratis.proto.RaftProtos.GroupInfoReplyProto> groupInfo(
        org.apache.ratis.proto.RaftProtos.GroupInfoRequestProto request) {
      return futureUnaryCall(
          getChannel().newCall(getGroupInfoMethod(), getCallOptions()), request);
    }
  }

  private static final int METHODID_SUBMIT_CLIENT_REQUEST = 0;
  private static final int METHODID_SET_CONFIGURATION = 1;
  private static final int METHODID_GROUP_MANAGEMENT = 2;
  private static final int METHODID_GROUP_LIST = 3;
  private static final int METHODID_GROUP_INFO = 4;

  private static final class MethodHandlers<Req, Resp> implements
      org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
      org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
      org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
      org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {
    private final CombinedClientProtocolServiceImplBase serviceImpl;
    private final int methodId;

    MethodHandlers(CombinedClientProtocolServiceImplBase serviceImpl, int methodId) {
      this.serviceImpl = serviceImpl;
      this.methodId = methodId;
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public void invoke(Req request, org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_SUBMIT_CLIENT_REQUEST:
          serviceImpl.submitClientRequest((org.apache.ratis.proto.RaftProtos.RaftClientRequestProto) request,
              (org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RaftClientReplyProto>) responseObserver);
          break;
        case METHODID_SET_CONFIGURATION:
          serviceImpl.setConfiguration((org.apache.ratis.proto.RaftProtos.SetConfigurationRequestProto) request,
              (org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RaftClientReplyProto>) responseObserver);
          break;
        case METHODID_GROUP_MANAGEMENT:
          serviceImpl.groupManagement((org.apache.ratis.proto.RaftProtos.GroupManagementRequestProto) request,
              (org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RaftClientReplyProto>) responseObserver);
          break;
        case METHODID_GROUP_LIST:
          serviceImpl.groupList((org.apache.ratis.proto.RaftProtos.GroupListRequestProto) request,
              (org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.GroupListReplyProto>) responseObserver);
          break;
        case METHODID_GROUP_INFO:
          serviceImpl.groupInfo((org.apache.ratis.proto.RaftProtos.GroupInfoRequestProto) request,
              (org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.GroupInfoReplyProto>) responseObserver);
          break;
        default:
          throw new AssertionError();
      }
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<Req> invoke(
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        default:
          throw new AssertionError();
      }
    }
  }

  private static abstract class CombinedClientProtocolServiceBaseDescriptorSupplier
      implements org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoFileDescriptorSupplier, org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoServiceDescriptorSupplier {
    CombinedClientProtocolServiceBaseDescriptorSupplier() {}

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FileDescriptor getFileDescriptor() {
      return org.apache.ratis.proto.hadoop.HadoopProtos.getDescriptor();
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.ServiceDescriptor getServiceDescriptor() {
      return getFileDescriptor().findServiceByName("CombinedClientProtocolService");
    }
  }

  private static final class CombinedClientProtocolServiceFileDescriptorSupplier
      extends CombinedClientProtocolServiceBaseDescriptorSupplier {
    CombinedClientProtocolServiceFileDescriptorSupplier() {}
  }

  private static final class CombinedClientProtocolServiceMethodDescriptorSupplier
      extends CombinedClientProtocolServiceBaseDescriptorSupplier
      implements org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoMethodDescriptorSupplier {
    private final String methodName;

    CombinedClientProtocolServiceMethodDescriptorSupplier(String methodName) {
      this.methodName = methodName;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.MethodDescriptor getMethodDescriptor() {
      return getServiceDescriptor().findMethodByName(methodName);
    }
  }

  private static volatile org.apache.ratis.thirdparty.io.grpc.ServiceDescriptor serviceDescriptor;

  public static org.apache.ratis.thirdparty.io.grpc.ServiceDescriptor getServiceDescriptor() {
    org.apache.ratis.thirdparty.io.grpc.ServiceDescriptor result = serviceDescriptor;
    if (result == null) {
      synchronized (CombinedClientProtocolServiceGrpc.class) {
        result = serviceDescriptor;
        if (result == null) {
          serviceDescriptor = result = org.apache.ratis.thirdparty.io.grpc.ServiceDescriptor.newBuilder(SERVICE_NAME)
              .setSchemaDescriptor(new CombinedClientProtocolServiceFileDescriptorSupplier())
              .addMethod(getSubmitClientRequestMethod())
              .addMethod(getSetConfigurationMethod())
              .addMethod(getGroupManagementMethod())
              .addMethod(getGroupListMethod())
              .addMethod(getGroupInfoMethod())
              .build();
        }
      }
    }
    return result;
  }
}
