package org.apache.ratis.proto.hadoop;

import static org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.generateFullMethodName;
import static org.apache.ratis.thirdparty.io.grpc.stub.ClientCalls.asyncBidiStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ClientCalls.asyncClientStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ClientCalls.asyncServerStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ClientCalls.asyncUnaryCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ClientCalls.blockingServerStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ClientCalls.blockingUnaryCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ClientCalls.futureUnaryCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.asyncBidiStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.asyncClientStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.asyncServerStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.asyncUnaryCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.asyncUnimplementedStreamingCall;
import static org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall;

/**
 */
@javax.annotation.Generated(
    value = "by gRPC proto compiler (version 1.28.1)",
    comments = "Source: Hadoop.proto")
public final class RaftServerProtocolServiceGrpc {

  private RaftServerProtocolServiceGrpc() {}

  public static final String SERVICE_NAME = "ratis.hadoop.RaftServerProtocolService";

  // Static method descriptors that strictly reflect the proto.
  private static volatile org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.RequestVoteRequestProto,
      org.apache.ratis.proto.RaftProtos.RequestVoteReplyProto> getRequestVoteMethod;

  @org.apache.ratis.thirdparty.io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "requestVote",
      requestType = org.apache.ratis.proto.RaftProtos.RequestVoteRequestProto.class,
      responseType = org.apache.ratis.proto.RaftProtos.RequestVoteReplyProto.class,
      methodType = org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.MethodType.UNARY)
  public static org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.RequestVoteRequestProto,
      org.apache.ratis.proto.RaftProtos.RequestVoteReplyProto> getRequestVoteMethod() {
    org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.RequestVoteRequestProto, org.apache.ratis.proto.RaftProtos.RequestVoteReplyProto> getRequestVoteMethod;
    if ((getRequestVoteMethod = RaftServerProtocolServiceGrpc.getRequestVoteMethod) == null) {
      synchronized (RaftServerProtocolServiceGrpc.class) {
        if ((getRequestVoteMethod = RaftServerProtocolServiceGrpc.getRequestVoteMethod) == null) {
          RaftServerProtocolServiceGrpc.getRequestVoteMethod = getRequestVoteMethod =
              org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.<org.apache.ratis.proto.RaftProtos.RequestVoteRequestProto, org.apache.ratis.proto.RaftProtos.RequestVoteReplyProto>newBuilder()
              .setType(org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "requestVote"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoUtils.marshaller(
                  org.apache.ratis.proto.RaftProtos.RequestVoteRequestProto.getDefaultInstance()))
              .setResponseMarshaller(org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoUtils.marshaller(
                  org.apache.ratis.proto.RaftProtos.RequestVoteReplyProto.getDefaultInstance()))
              .setSchemaDescriptor(new RaftServerProtocolServiceMethodDescriptorSupplier("requestVote"))
              .build();
        }
      }
    }
    return getRequestVoteMethod;
  }

  private static volatile org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.AppendEntriesRequestProto,
      org.apache.ratis.proto.RaftProtos.AppendEntriesReplyProto> getAppendEntriesMethod;

  @org.apache.ratis.thirdparty.io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "appendEntries",
      requestType = org.apache.ratis.proto.RaftProtos.AppendEntriesRequestProto.class,
      responseType = org.apache.ratis.proto.RaftProtos.AppendEntriesReplyProto.class,
      methodType = org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.MethodType.UNARY)
  public static org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.AppendEntriesRequestProto,
      org.apache.ratis.proto.RaftProtos.AppendEntriesReplyProto> getAppendEntriesMethod() {
    org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.AppendEntriesRequestProto, org.apache.ratis.proto.RaftProtos.AppendEntriesReplyProto> getAppendEntriesMethod;
    if ((getAppendEntriesMethod = RaftServerProtocolServiceGrpc.getAppendEntriesMethod) == null) {
      synchronized (RaftServerProtocolServiceGrpc.class) {
        if ((getAppendEntriesMethod = RaftServerProtocolServiceGrpc.getAppendEntriesMethod) == null) {
          RaftServerProtocolServiceGrpc.getAppendEntriesMethod = getAppendEntriesMethod =
              org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.<org.apache.ratis.proto.RaftProtos.AppendEntriesRequestProto, org.apache.ratis.proto.RaftProtos.AppendEntriesReplyProto>newBuilder()
              .setType(org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "appendEntries"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoUtils.marshaller(
                  org.apache.ratis.proto.RaftProtos.AppendEntriesRequestProto.getDefaultInstance()))
              .setResponseMarshaller(org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoUtils.marshaller(
                  org.apache.ratis.proto.RaftProtos.AppendEntriesReplyProto.getDefaultInstance()))
              .setSchemaDescriptor(new RaftServerProtocolServiceMethodDescriptorSupplier("appendEntries"))
              .build();
        }
      }
    }
    return getAppendEntriesMethod;
  }

  private static volatile org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.InstallSnapshotRequestProto,
      org.apache.ratis.proto.RaftProtos.InstallSnapshotReplyProto> getInstallSnapshotMethod;

  @org.apache.ratis.thirdparty.io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "installSnapshot",
      requestType = org.apache.ratis.proto.RaftProtos.InstallSnapshotRequestProto.class,
      responseType = org.apache.ratis.proto.RaftProtos.InstallSnapshotReplyProto.class,
      methodType = org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.MethodType.UNARY)
  public static org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.InstallSnapshotRequestProto,
      org.apache.ratis.proto.RaftProtos.InstallSnapshotReplyProto> getInstallSnapshotMethod() {
    org.apache.ratis.thirdparty.io.grpc.MethodDescriptor<org.apache.ratis.proto.RaftProtos.InstallSnapshotRequestProto, org.apache.ratis.proto.RaftProtos.InstallSnapshotReplyProto> getInstallSnapshotMethod;
    if ((getInstallSnapshotMethod = RaftServerProtocolServiceGrpc.getInstallSnapshotMethod) == null) {
      synchronized (RaftServerProtocolServiceGrpc.class) {
        if ((getInstallSnapshotMethod = RaftServerProtocolServiceGrpc.getInstallSnapshotMethod) == null) {
          RaftServerProtocolServiceGrpc.getInstallSnapshotMethod = getInstallSnapshotMethod =
              org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.<org.apache.ratis.proto.RaftProtos.InstallSnapshotRequestProto, org.apache.ratis.proto.RaftProtos.InstallSnapshotReplyProto>newBuilder()
              .setType(org.apache.ratis.thirdparty.io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "installSnapshot"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoUtils.marshaller(
                  org.apache.ratis.proto.RaftProtos.InstallSnapshotRequestProto.getDefaultInstance()))
              .setResponseMarshaller(org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoUtils.marshaller(
                  org.apache.ratis.proto.RaftProtos.InstallSnapshotReplyProto.getDefaultInstance()))
              .setSchemaDescriptor(new RaftServerProtocolServiceMethodDescriptorSupplier("installSnapshot"))
              .build();
        }
      }
    }
    return getInstallSnapshotMethod;
  }

  /**
   * Creates a new async stub that supports all call types for the service
   */
  public static RaftServerProtocolServiceStub newStub(org.apache.ratis.thirdparty.io.grpc.Channel channel) {
    org.apache.ratis.thirdparty.io.grpc.stub.AbstractStub.StubFactory<RaftServerProtocolServiceStub> factory =
      new org.apache.ratis.thirdparty.io.grpc.stub.AbstractStub.StubFactory<RaftServerProtocolServiceStub>() {
        @java.lang.Override
        public RaftServerProtocolServiceStub newStub(org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
          return new RaftServerProtocolServiceStub(channel, callOptions);
        }
      };
    return RaftServerProtocolServiceStub.newStub(factory, channel);
  }

  /**
   * Creates a new blocking-style stub that supports unary and streaming output calls on the service
   */
  public static RaftServerProtocolServiceBlockingStub newBlockingStub(
      org.apache.ratis.thirdparty.io.grpc.Channel channel) {
    org.apache.ratis.thirdparty.io.grpc.stub.AbstractStub.StubFactory<RaftServerProtocolServiceBlockingStub> factory =
      new org.apache.ratis.thirdparty.io.grpc.stub.AbstractStub.StubFactory<RaftServerProtocolServiceBlockingStub>() {
        @java.lang.Override
        public RaftServerProtocolServiceBlockingStub newStub(org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
          return new RaftServerProtocolServiceBlockingStub(channel, callOptions);
        }
      };
    return RaftServerProtocolServiceBlockingStub.newStub(factory, channel);
  }

  /**
   * Creates a new ListenableFuture-style stub that supports unary calls on the service
   */
  public static RaftServerProtocolServiceFutureStub newFutureStub(
      org.apache.ratis.thirdparty.io.grpc.Channel channel) {
    org.apache.ratis.thirdparty.io.grpc.stub.AbstractStub.StubFactory<RaftServerProtocolServiceFutureStub> factory =
      new org.apache.ratis.thirdparty.io.grpc.stub.AbstractStub.StubFactory<RaftServerProtocolServiceFutureStub>() {
        @java.lang.Override
        public RaftServerProtocolServiceFutureStub newStub(org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
          return new RaftServerProtocolServiceFutureStub(channel, callOptions);
        }
      };
    return RaftServerProtocolServiceFutureStub.newStub(factory, channel);
  }

  /**
   */
  public static abstract class RaftServerProtocolServiceImplBase implements org.apache.ratis.thirdparty.io.grpc.BindableService {

    /**
     */
    public void requestVote(org.apache.ratis.proto.RaftProtos.RequestVoteRequestProto request,
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RequestVoteReplyProto> responseObserver) {
      asyncUnimplementedUnaryCall(getRequestVoteMethod(), responseObserver);
    }

    /**
     */
    public void appendEntries(org.apache.ratis.proto.RaftProtos.AppendEntriesRequestProto request,
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.AppendEntriesReplyProto> responseObserver) {
      asyncUnimplementedUnaryCall(getAppendEntriesMethod(), responseObserver);
    }

    /**
     */
    public void installSnapshot(org.apache.ratis.proto.RaftProtos.InstallSnapshotRequestProto request,
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.InstallSnapshotReplyProto> responseObserver) {
      asyncUnimplementedUnaryCall(getInstallSnapshotMethod(), responseObserver);
    }

    @java.lang.Override public final org.apache.ratis.thirdparty.io.grpc.ServerServiceDefinition bindService() {
      return org.apache.ratis.thirdparty.io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
          .addMethod(
            getRequestVoteMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                org.apache.ratis.proto.RaftProtos.RequestVoteRequestProto,
                org.apache.ratis.proto.RaftProtos.RequestVoteReplyProto>(
                  this, METHODID_REQUEST_VOTE)))
          .addMethod(
            getAppendEntriesMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                org.apache.ratis.proto.RaftProtos.AppendEntriesRequestProto,
                org.apache.ratis.proto.RaftProtos.AppendEntriesReplyProto>(
                  this, METHODID_APPEND_ENTRIES)))
          .addMethod(
            getInstallSnapshotMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                org.apache.ratis.proto.RaftProtos.InstallSnapshotRequestProto,
                org.apache.ratis.proto.RaftProtos.InstallSnapshotReplyProto>(
                  this, METHODID_INSTALL_SNAPSHOT)))
          .build();
    }
  }

  /**
   */
  public static final class RaftServerProtocolServiceStub extends org.apache.ratis.thirdparty.io.grpc.stub.AbstractAsyncStub<RaftServerProtocolServiceStub> {
    private RaftServerProtocolServiceStub(
        org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected RaftServerProtocolServiceStub build(
        org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
      return new RaftServerProtocolServiceStub(channel, callOptions);
    }

    /**
     */
    public void requestVote(org.apache.ratis.proto.RaftProtos.RequestVoteRequestProto request,
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RequestVoteReplyProto> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getRequestVoteMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void appendEntries(org.apache.ratis.proto.RaftProtos.AppendEntriesRequestProto request,
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.AppendEntriesReplyProto> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getAppendEntriesMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void installSnapshot(org.apache.ratis.proto.RaftProtos.InstallSnapshotRequestProto request,
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.InstallSnapshotReplyProto> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getInstallSnapshotMethod(), getCallOptions()), request, responseObserver);
    }
  }

  /**
   */
  public static final class RaftServerProtocolServiceBlockingStub extends org.apache.ratis.thirdparty.io.grpc.stub.AbstractBlockingStub<RaftServerProtocolServiceBlockingStub> {
    private RaftServerProtocolServiceBlockingStub(
        org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected RaftServerProtocolServiceBlockingStub build(
        org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
      return new RaftServerProtocolServiceBlockingStub(channel, callOptions);
    }

    /**
     */
    public org.apache.ratis.proto.RaftProtos.RequestVoteReplyProto requestVote(org.apache.ratis.proto.RaftProtos.RequestVoteRequestProto request) {
      return blockingUnaryCall(
          getChannel(), getRequestVoteMethod(), getCallOptions(), request);
    }

    /**
     */
    public org.apache.ratis.proto.RaftProtos.AppendEntriesReplyProto appendEntries(org.apache.ratis.proto.RaftProtos.AppendEntriesRequestProto request) {
      return blockingUnaryCall(
          getChannel(), getAppendEntriesMethod(), getCallOptions(), request);
    }

    /**
     */
    public org.apache.ratis.proto.RaftProtos.InstallSnapshotReplyProto installSnapshot(org.apache.ratis.proto.RaftProtos.InstallSnapshotRequestProto request) {
      return blockingUnaryCall(
          getChannel(), getInstallSnapshotMethod(), getCallOptions(), request);
    }
  }

  /**
   */
  public static final class RaftServerProtocolServiceFutureStub extends org.apache.ratis.thirdparty.io.grpc.stub.AbstractFutureStub<RaftServerProtocolServiceFutureStub> {
    private RaftServerProtocolServiceFutureStub(
        org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected RaftServerProtocolServiceFutureStub build(
        org.apache.ratis.thirdparty.io.grpc.Channel channel, org.apache.ratis.thirdparty.io.grpc.CallOptions callOptions) {
      return new RaftServerProtocolServiceFutureStub(channel, callOptions);
    }

    /**
     */
    public org.apache.ratis.thirdparty.com.google.common.util.concurrent.ListenableFuture<org.apache.ratis.proto.RaftProtos.RequestVoteReplyProto> requestVote(
        org.apache.ratis.proto.RaftProtos.RequestVoteRequestProto request) {
      return futureUnaryCall(
          getChannel().newCall(getRequestVoteMethod(), getCallOptions()), request);
    }

    /**
     */
    public org.apache.ratis.thirdparty.com.google.common.util.concurrent.ListenableFuture<org.apache.ratis.proto.RaftProtos.AppendEntriesReplyProto> appendEntries(
        org.apache.ratis.proto.RaftProtos.AppendEntriesRequestProto request) {
      return futureUnaryCall(
          getChannel().newCall(getAppendEntriesMethod(), getCallOptions()), request);
    }

    /**
     */
    public org.apache.ratis.thirdparty.com.google.common.util.concurrent.ListenableFuture<org.apache.ratis.proto.RaftProtos.InstallSnapshotReplyProto> installSnapshot(
        org.apache.ratis.proto.RaftProtos.InstallSnapshotRequestProto request) {
      return futureUnaryCall(
          getChannel().newCall(getInstallSnapshotMethod(), getCallOptions()), request);
    }
  }

  private static final int METHODID_REQUEST_VOTE = 0;
  private static final int METHODID_APPEND_ENTRIES = 1;
  private static final int METHODID_INSTALL_SNAPSHOT = 2;

  private static final class MethodHandlers<Req, Resp> implements
      org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
      org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
      org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
      org.apache.ratis.thirdparty.io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {
    private final RaftServerProtocolServiceImplBase serviceImpl;
    private final int methodId;

    MethodHandlers(RaftServerProtocolServiceImplBase serviceImpl, int methodId) {
      this.serviceImpl = serviceImpl;
      this.methodId = methodId;
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public void invoke(Req request, org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_REQUEST_VOTE:
          serviceImpl.requestVote((org.apache.ratis.proto.RaftProtos.RequestVoteRequestProto) request,
              (org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.RequestVoteReplyProto>) responseObserver);
          break;
        case METHODID_APPEND_ENTRIES:
          serviceImpl.appendEntries((org.apache.ratis.proto.RaftProtos.AppendEntriesRequestProto) request,
              (org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.AppendEntriesReplyProto>) responseObserver);
          break;
        case METHODID_INSTALL_SNAPSHOT:
          serviceImpl.installSnapshot((org.apache.ratis.proto.RaftProtos.InstallSnapshotRequestProto) request,
              (org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<org.apache.ratis.proto.RaftProtos.InstallSnapshotReplyProto>) responseObserver);
          break;
        default:
          throw new AssertionError();
      }
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<Req> invoke(
        org.apache.ratis.thirdparty.io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        default:
          throw new AssertionError();
      }
    }
  }

  private static abstract class RaftServerProtocolServiceBaseDescriptorSupplier
      implements org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoFileDescriptorSupplier, org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoServiceDescriptorSupplier {
    RaftServerProtocolServiceBaseDescriptorSupplier() {}

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FileDescriptor getFileDescriptor() {
      return org.apache.ratis.proto.hadoop.HadoopProtos.getDescriptor();
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.ServiceDescriptor getServiceDescriptor() {
      return getFileDescriptor().findServiceByName("RaftServerProtocolService");
    }
  }

  private static final class RaftServerProtocolServiceFileDescriptorSupplier
      extends RaftServerProtocolServiceBaseDescriptorSupplier {
    RaftServerProtocolServiceFileDescriptorSupplier() {}
  }

  private static final class RaftServerProtocolServiceMethodDescriptorSupplier
      extends RaftServerProtocolServiceBaseDescriptorSupplier
      implements org.apache.ratis.thirdparty.io.grpc.protobuf.ProtoMethodDescriptorSupplier {
    private final String methodName;

    RaftServerProtocolServiceMethodDescriptorSupplier(String methodName) {
      this.methodName = methodName;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.MethodDescriptor getMethodDescriptor() {
      return getServiceDescriptor().findMethodByName(methodName);
    }
  }

  private static volatile org.apache.ratis.thirdparty.io.grpc.ServiceDescriptor serviceDescriptor;

  public static org.apache.ratis.thirdparty.io.grpc.ServiceDescriptor getServiceDescriptor() {
    org.apache.ratis.thirdparty.io.grpc.ServiceDescriptor result = serviceDescriptor;
    if (result == null) {
      synchronized (RaftServerProtocolServiceGrpc.class) {
        result = serviceDescriptor;
        if (result == null) {
          serviceDescriptor = result = org.apache.ratis.thirdparty.io.grpc.ServiceDescriptor.newBuilder(SERVICE_NAME)
              .setSchemaDescriptor(new RaftServerProtocolServiceFileDescriptorSupplier())
              .addMethod(getRequestVoteMethod())
              .addMethod(getAppendEntriesMethod())
              .addMethod(getInstallSnapshotMethod())
              .build();
        }
      }
    }
    return result;
  }
}
